clear all;
clc;
close all;

x = 0:0.01:20;
num_plot = size(x, 2);
f1 = abs(besselj(0, x));
f2 = sqrt(besselj(0, x).^2+besselj(1, x).^2);

C = linspecer(6);
figure;
hold on;
plot(x, f1,'r-','LineWidth',1.5,'color', C(2,:));
plot(x, f2,'b-','LineWidth',1.5,'color', C(1,:));
legend('$|J_0(\zeta)|$ for UCA', '$(J_0^2(\zeta)+J_1^2(\zeta))^{1/2}$ for UCCA','interpreter','latex');
xlabel('$\zeta$','interpreter','latex');
ylabel('$f(\zeta)$','interpreter','latex');
grid on;
box on;

set(gca,'XTick',[2:2:20],'YTick',[0:0.1:1]);
set(0,'defaultfigurecolor','w');
axis([0 20 0 1]);

