function [H, H_approx, dis_matrix, dis_approx] =...
    generate_con_UCA_3D(fc, Nt_list, r_radius_list, r_list, theta_list, phi_list)

c = 3e8;
lambda = c/fc;
[~, d_len] = size(r_list);
[~, M] = size(Nt_list);

%% channel generation
Nt_total = sum(Nt_list);
H = zeros(d_len, Nt_total);
H_approx = zeros(d_len, Nt_total);
for i_d = 1:d_len
    r0 = r_list(i_d);
    theta0 = theta_list(i_d);
    
    for i_m = 1:M
        r_radius = r_radius_list(i_m);
        Nt = Nt_list(i_m);
        
        %% UCA settings
        pp = 1:1:Nt;
        phi_p = (pp-1)*2*pi/Nt;
        [x_p, y_p] = pol2cart(phi_p, r_radius);
        
        r0_xy = r0*sin(theta0);
        r0_z = r0*cos(theta0);
        phi0 = phi_list(i_d);
        [x0, y0] = pol2cart(phi0, r0_xy);

        dis_matrix = sqrt((x_p-x0).^2+(y_p-y0).^2+r0_z.^2);
        dis_approx = r0-r_radius*sin(theta0)*cos(phi0-phi_p)+r_radius^2/2/r0*(1-sin(theta0)^2*cos(phi0-phi_p).^2);
        err = dis_matrix-dis_approx;
        at = exp(-1i*2*pi/lambda*dis_matrix)/sqrt(Nt_total);

        idx_start = sum(Nt_list(1:i_m))-Nt+1;
        idx_end = idx_start+Nt-1;
        H(i_d, idx_start:idx_end) = at;
        H_approx(i_d, idx_start:idx_end) = exp(-1i*2*pi/lambda*dis_approx)/sqrt(Nt_total);
    end
end

